|  | Home · All Classes · Modules

# QAbstractUriResolver Class Reference
[QtXmlPatterns module]

The QAbstractUriResolver class is a callback interface for resolving Uniform Resource Identifiers. More...

Inherits QObject.

### Methods

- __init__ (self, QObject parent = None)
- QUrl resolve (self, QUrl relative, QUrl baseURI)

## Detailed Description

The QAbstractUriResolver class is a callback interface for resolving Uniform Resource Identifiers.

A Uniform Resource Identifier (URI) is a string that uniquely identifies a resource. URIs are versatile global identifiers. It is often useful to transform a URI that identifies something logical into a URI that locates something physical (a URL), or to simply map a URI to a different URI. QAbstractUriResolver.resolve() provides this functionality.

For example, one could write a QAbstractUriResolver subclass that rewrites library ISBN number URIs as book title URLs, e.g., urn:isbn:0-345-33973-8 would be rewritten as file:///books/returnOfTheKing.doc. Or a QAbstractUriResolver subclass could be written for a web browser to let the web browser protect the user's private files by mapping incoming requests for them to null URIs.

## Method Documentation

### QAbstractUriResolver.__init__ (self, QObject parent = None)

The parent argument, if not None, causes self to be owned by Qt instead of PyQt.

Constructs a QAbstractUriResolver with the specified parent.

### QUrl QAbstractUriResolver.resolve (self, QUrl relative, QUrl baseURI)

This method is abstract and should be reimplemented in any sub-class.

Returns the relative URI resolved using the baseURI.

The caller guarantees that both relative and baseURI are valid, and that baseURI is absolute. relative can be relative, absolute, or empty.

The returned QUrl can be a default constructed QUrl. If it is not a default constructed QUrl, it will be absolute and valid. If a default constructed QUrl is returned, it means the relative URI was not accepted to be resolved.

If the reimplemented resolve() function decides it has nothing to do about resolving the relative URI, it should simply return the relative URI resolved against the baseURI, i.e.:

     return baseURI.resolved(relative);

See also QUrl.isRelative() and QUrl.isValid().